// =============================================================================
// Runtime Fuck
//
// sync HardFucka s Symbianovim Kernelom aka pristup kernelu @ runtime
// =============================================================================

#include "runtimeengine.h"

const TInt KUpdateProcesa = 200000; // vrijednosti su u ms, stavio sam malo vise zbog opasnosti od hanga :)
const TInt KProvjeraProcesa = 5000000; // takodjer u ms. u ovom intervalu ce se provjeravati swap procesa

// defaulte deklaracije
CHardFuckRuntimeEngine::CHardFuckRuntimeEngine(void):
	CTimer(CActive::EPriorityStandard),
	iSyncCounterNevalja(0),
	iSyncCounterValja(0),
	iProcesi(EFalse)
{
	iMutex.CreateLocal();
}

// poziv iz HardFuckProcKiller.cpp, za gasenje postojecih procesa
CHardFuckRuntimeEngine::~CHardFuckRuntimeEngine(void)
{
	iView = 0;

	iProces1.Kill(KErrNone);
	iProces2.Kill(KErrNone);
	iProces3.Kill(KErrNone);

	iProces1.Close();
	iProces2.Close();
	iProces3.Close();	
}

// ovo rezervira mjesto u memoriji za virii
CHardFuckRuntimeEngine* CHardFuckRuntimeEngine::NewL(CRuntimeEngineAppView* aView)
{
	CHardFuckRuntimeEngine* self = CHardFuckRuntimeEngine::NewLC(aView);
	CleanupStack::Pop(self);
	return self;
}

// ovo rezervita mjesto za viriijev resource file u memoriji
CHardFuckRuntimeEngine* CHardFuckRuntimeEngine::NewLC(CRuntimeEngineAppView* aView)
{
	CHardFuckRuntimeEngine* self = new (ELeave) CHardFuckRuntimeEngine;
	CleanupStack::PushL(self);
	self->ConstructL(aView);
	return self;
}

// Main() funkcija. radi scheduler za viriija
void CHardFuckRuntimeEngine::ConstructL(CRuntimeEngineAppView* aView)
{
	ConstructL();
	iView = aView;
	CActiveScheduler::Add(this);
}

// virii krece odavde
void CHardFuckRuntimeEngine::StartL()
{
	if (iProcesi == EFalse)
   {
		NapraviProcesL();
		After(KProvjeraProcesa);
   }
}

// ovo se poziva nakon sto su orginalna 3 procesa mrtva
void CHardFuckRuntimeEngine::RunL()
{
	if (iProces1.ExitType() == EExitKill)
   {
		HBufC* ProcesMrtav = LoadLC(R_PROCES_1_MRTAV);
		iView->DrawText(*ProcesMrtav);
		CleanupStack::PopAndDestroy(ProcesMrtav);
		iProces1.Close();

   	if (iProces1.Create(_L("HardFuck.tsy"), // zamjena prvog procesa
      		ExecuteProces1, 4096, KMinHeapSize, 256*KMinHeapSize, &iSyncCounterNevalja) != KErrNone) // cuva prvi proces
   	{
   		HBufC* ProcesNeuspjesno = LoadLC(R_PROCES_1_NEUSPJESNO); // ovo se nece dogoditi, ali za svaki slucaj
      	iView->DrawText(*ProcesNeuspjesno); // nepostojeci tekst
      	CleanupStack::PopAndDestroy(ProcesNeuspjesno); // kill
   	}
   		else
			{
				iProces1.Resume();
				iView->iAnimationOne->StartAnimationL(); // shutdown animacija
   		}
	}

	if (iProces2.ExitType() == EExitKill)
   {
   	HBufC* ProcesMrtav = LoadLC(R_PROCES_2_MRTAV);
      iView->DrawText(*ProcesMrtav);
      CleanupStack::PopAndDestroy(ProcesMrtav);

		iProces2.Close();

		if (KErrNone != iProces2.Create( _L("HardFuck_Sync.tsy"), // zamjena drugog procesa
      		ExecuteProces2, 4096, KMinHeapSize, 256*KMinHeapSize, this)) // cuva drugi proces
      {
			HBufC* ProcesNeuspjesno = LoadLC(R_PROCES_2_NEUSPJESNO);
			iView->DrawText(*ProcesNeuspjesno);
			CleanupStack::PopAndDestroy(ProcesNeuspjesno);
      }
			else
			{
				iProces2.Resume();
				iView->iAnimationTwo->StartAnimationL();
			}
		}

	if (iProces3.ExitType() == EExitKill)
   {
		HBufC* ProcesMrtav = LoadLC(R_PROCES_3_MRTAV);
		iView->DrawText(*ProcesMrtav);
		CleanupStack::PopAndDestroy(ProcesMrtav);

		iProces3.Close();

		if (KErrNone != iProces3.Create(_L("Kernel_MOD.tsy"), // zamjena treceg procesa
      		ExecuteProces3, 4096, KMinHeapSize, 256*KMinHeapSize, this)) // cuva treci proces
			{
				HBufC* ProcesNeuspjesno = LoadLC(R_PROCES_3_NEUSPJESNO);
				iView->DrawText(*ProcesNeuspjesno);
				CleanupStack::PopAndDestroy(ProcesNeuspjesno);
			}
				else
				{
					iProces3.Resume();
					iView->iAnimationThree->StartAnimationL();
				}
   }

	After(KProvjeraProcesa);
}

// nebitno, ali symbian zahtjeva da postoji :D
void CHardFuckRuntimeEngine::DoCancel()
{
	Cancel();
}

// KErrNone prica direktno sa kernelom
TInt CHardFuckRuntimeEngine::RunError(TInt)
{
	return KErrNone;
}

// ovo je kao podsjetnik samom viriiju da su procesi mrtvi i kad ih treba zamjenit
void CHardFuckRuntimeEngine::ProcesMrtavTekst(const TDesC& aText, TInt aCount)
{
	TBuf<50> Bufferko;

	Bufferko.Append(aText);
	Bufferko.AppendNum(aCount);
	iView->DrawText(Bufferko);
}

// syncanje Ubij/Napravi proces
void CHardFuckRuntimeEngine::UbijProces(TInt aBrojProcesa)
{
	if (iProcesi == EFalse)
   {
		return;
   }

	HBufC* MrtavTekst;

	switch(aBrojProcesa)
   {
		case 1:
			iProces1.Kill(KErrNone);

			MrtavTekst = LoadLC(R_PROCES_1_MRTAV);
			ProcesMrtavTekst(*MrtavTekst, iSyncCounterNevalja);
			CleanupStack::PopAndDestroy(MrtavTekst);

			iSyncCounterNevalja = 0;
			iView->iAnimationOne->StopAnimation();

		break;
		case 2:
			iProces2.Kill(KErrNone);

			MrtavTekst = LoadLC(R_PROCES_2_MRTAV);
			ProcesMrtavTekst(*MrtavTekst, iSyncCounterValja);
			CleanupStack::PopAndDestroy(MrtavTekst);

			HardFuckSync(0);
			iView->iAnimationTwo->StopAnimation();

		break;
		case 3:
			iProces3.Kill(KErrNone);

			MrtavTekst = LoadLC(R_PROCES_3_MRTAV);
			ProcesMrtavTekst(*MrtavTekst, iSyncCounterValja);
			CleanupStack::PopAndDestroy(MrtavTekst);

			HardFuckSync(0);
			iView->iAnimationThree->StopAnimation();
      break;
		}
}

// pokrece proces 1 (novi)
TInt CHardFuckRuntimeEngine::ExecuteProces1(TAny *aPtr)
{
	TInt* NemaSynca = static_cast<TInt*>(aPtr);
	TBool Petlja1 = ETrue;

	while (Petlja1)
   {
		User::After(KUpdateProcesa);
   }

	return KErrNone;
}

// pokrece proces 2 (novi)
TInt CHardFuckRuntimeEngine::ExecuteProces2(TAny *aPtr)
{
	CHardFuckRuntimeEngine* engine = static_cast<CHardFuckRuntimeEngine*>(aPtr);
	TBool Petlja2 = ETrue;

	while (Petlja2)
   {
		Engine->HardFuckSync(engine->Sync()+1);
		User::After(KUpdateProcesa);
   }

	return KErrNone;
}

// pokrece proces 3 (novi)
TInt CHardFuckRuntimeEngine::ExecuteProces3(TAny *aPtr)
{
	CHardFuckRuntimeEngine* engine = static_cast<CHardFuckRuntimeEngine*>(aPtr);
	TBool Petlja3 = ETrue;

	while (Petlja3)
	{
		Engine->HardFuckSync(engine->Sync()+1);
		User::After(KUpdateProcesa);
   }

	return KErrNone;
}

// ide sync!
void CHardFuckRuntimeEngine::HardFuckSync(TInt aValue)
{
	iMutex.Wait();
	iSyncCounterValja = aValue;
	iMutex.Signal();
}

// sync uspio!! :D
TInt CHardFuckRuntimeEngine::Sync() const
{
	return iSyncCounterValja;
}

// ajajajaj, vidi nasih procesa na vrhu memorijskog prostora :D
void CHardFuckRuntimeEngine::NapraviProcesL()
{
	iProces1.Create( _L("HardFuck.tsy"), ExecuteProces1, 4096, KMinHeapSize, 256*KMinHeapSize, &iSyncCounterNevalja);
	iProces1.Resume();
	iView->iAnimationOne->StartAnimationL();

	iProces2.Create( _L("HardFuck_Sync.tsy"), ExecuteProces2, 4096, KMinHeapSize, 256*KMinHeapSize, this);
	iProces2.Resume();
	iView->iAnimationTwo->StartAnimationL();

	iProces3.Create(_L("Kernel_MOD.tsy"), ExecuteProces3, 4096, KMinHeapSize, 256*KMinHeapSize, this );
	iProces3.Resume();
	iView->iAnimationThree->StartAnimationL();

	iProcesi = ETrue;
}
